/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include <dawn/dawn.h>

/**
 * Returns the language string for a given language string key.
 * 
 * @param language Language to get from.
 * @param key Key to get from.
 * @return The string matching the key, or NULL if no match.
 */
languagestring_t * languageGetStringByKey(language_t *language, char *key);

/**
 * Returns the value for a given language string.
 * 
 * @param language Language to get from.
 * @param string Language string to get.
 * @return The string.
 */
char * languageGetText(language_t *language, languagestring_t *string);

char * languageGetTextWithVariables(
  language_t *language, languagestring_t *string, languagevariable_t *variable
);